﻿# -*- coding: utf-8 -*-

import sys
import os
import re
import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon
import platform
import json
import xbmcvfs
import shutil
import socket
import time
import io
from datetime import datetime
import pyxbmct
import base64
import hashlib
import uuid
from platform import node
from requests import session, utils, exceptions
PY2 = sys.version_info[0] == 2
if PY2:
	from urllib import urlencode, unquote_plus  # Python 2.X
else: 
	from urllib.parse import urlencode, unquote_plus  # Python 3.X
from Cryptodome.Cipher import DES3
from Cryptodome.Util.Padding import pad, unpad
import warnings
warnings.filterwarnings('ignore', message='Unverified HTTPS request')


global debuging
HOST_AND_PATH       = sys.argv[0]
ADDON_HANDLE         = int(sys.argv[1])
dialog                             = xbmcgui.Dialog()
addon                             = xbmcaddon.Addon()
addonPath                     = xbmc.translatePath(addon.getAddonInfo('path')).encode('utf-8').decode('utf-8')
dataPath                        = xbmc.translatePath(addon.getAddonInfo('profile')).encode('utf-8').decode('utf-8')
tempCE                           = xbmc.translatePath(os.path.join(dataPath, 'tempCE', '')).encode('utf-8').decode('utf-8')
cookieFile                       = os.path.join(tempCE, 'COOKIE')
addon_id                        = addon.getAddonInfo('id')
addon_name                 = addon.getAddonInfo('name')
addon_version              = addon.getAddonInfo('version')
channelFavsFile            = os.path.join(dataPath, 'my_AOD_favourites.txt')
WORKFILE                     = os.path.join(dataPath, 'episode_data.txt')
defaultFanart                = os.path.join(addonPath, 'fanart.jpg')
icon                                 = os.path.join(addonPath, 'icon.png')
artpic                              = os.path.join(addonPath, 'resources', 'media', '').encode('utf-8').decode('utf-8')
username                      = addon.getSetting('username')
password                       = addon.getSetting('password')
CSRF_Token                  = addon.getSetting('csrftoken')
LOGIN_STATUS             = addon.getSetting('login_successfully')
QUALITY                         = {0:'Original-0000', 1:'Highest-0000', 2:'Select-0000', 3:'13568000-1081', 4:'9244661-1080', 5:'1839789-720', 6:'1146849-576', 7:'758348-480', 8:'688735-360'}[int(addon.getSetting('prefVideoQuality'))]
enableINPUTSTREAM  = addon.getSetting('useInputstream') == 'true'
INPUT_APP                    = ('inputstream' if int(xbmc.getInfoLabel('System.BuildVersion')[0:2]) >= 19 else 'inputstreamaddon')
enableTEASER               = addon.getSetting('show_teaser') == 'true'
no_Movies                      = addon.getSetting('show_movies') == 'false'
sel_CAT                           = addon.getSetting('select_categories')
useThumbAsFanart      = addon.getSetting('useThumbAsFanart') == 'true'
want_encrypt                = addon.getSetting('encrypt_credentials')
START_MODUS              = addon.getSetting('select_start')
verify_ssl_connect        = (True if addon.getSetting('verify_ssl') == 'true' else False)
enableADJUSTMENT     = addon.getSetting('show_settings') == 'true'
DEB_LEVEL                      = (xbmc.LOGNOTICE if addon.getSetting('enableDebug') == 'true' else xbmc.LOGDEBUG)
BASE_URL                        = 'https://www.anime-on-demand.de'
LOGIN_LINK                   = '{0}/users/sign_in'.format(BASE_URL)
LOGOUT_LINK                = '{0}/users/sign_out'.format(BASE_URL)

xbmcplugin.setContent(ADDON_HANDLE, 'tvshows')

def py2_enc(s, encoding='utf-8'):
	if PY2:
		if not isinstance(s, basestring):
			s = str(s)
		s = s.encode(encoding) if isinstance(s, unicode) else s
	return s

def py2_uni(s, encoding='utf-8'):
	if PY2 and isinstance(s, str):
		s = unicode(s, encoding)
	return s

def py3_dec(d, encoding='utf-8'):
	if not PY2 and isinstance(d, bytes):
		d = d.decode(encoding)
	return d

def translation(id):
	return py2_enc(addon.getLocalizedString(id))

def failing(content):
	log(content, xbmc.LOGERROR)

def debug_MS(content):
	log(content, DEB_LEVEL)

def log(msg, level=xbmc.LOGNOTICE):
	msg = py2_enc(msg)
	return xbmc.log('[{0} v.{1}]{2}'.format(addon_id, addon_version, msg), level)

def build_url(query):
	return '{0}?{1}'.format(HOST_AND_PATH, urlencode(query))

def ADDON_operate(IDD):
	js_query = xbmc.executeJSONRPC('{"jsonrpc": "2.0", "method": "Addons.GetAddonDetails", "params": {"addonid":"'+IDD+'", "properties": ["enabled"]}, "id":1}')
	if '"enabled":false' in js_query:
		try:
			xbmc.executeJSONRPC('{"jsonrpc": "2.0", "method": "Addons.SetAddonEnabled", "params": {"addonid":"'+IDD+'", "enabled":true}, "id":1}')
			failing("(ADDON_operate) ERROR - ERROR - ERROR :\n##### Das benötigte Addon : *{0}* ist NICHT aktiviert !!! #####\n##### Es wird jetzt versucht die Aktivierung durchzuführen !!! #####".format(IDD))
		except: pass
	if '"error":' in js_query:
		dialog.ok(addon_id, translation(30501).format(IDD))
		failing("(ADDON_operate) ERROR - ERROR - ERROR :\n##### Das benötigte Addon : *{0}* ist NICHT installiert !!! #####".format(IDD))
		return False
	if '"enabled":true' in js_query:
		return True

def get_userAgent():
	base = 'Mozilla/5.0 {0} AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.108 Safari/537.36'
	system = platform.system()
	# Mac OSX
	if system == 'Darwin':
		return base.format('(Macintosh; Intel Mac OS X 10_10_1)')
	# Windows
	if system == 'Windows':
		return base.format('(Windows NT 10.0; WOW64)')
	# ARM based Linux
	if platform.machine().startswith('arm'):
		return base.format('(X11; CrOS armv7l 7647.78.0)')
	# x86 Linux
	return base.format('(X11; Linux x86_64)')

def checking(text):
	subWords = ['OmU', 'Sub']
	for word in subWords:
		if word in text:
			return True
	return False

def repair_vokals(title):
	title = title.replace('Ã¤', 'ä').replace('Ã„', 'Ä').replace('Ã¶', 'ö').replace('Ã–', 'Ö').replace('Ã¼', 'ü').replace('Ãœ', 'Ü').replace('ÃŸ', 'ß')
	return title

def cleaning(text):
	text = py2_enc(text)
	for n in (('&lt;', '<'), ('&gt;', '>'), ('&amp;', '&'), ('&Amp;', '&'), ('&apos;', "'"), ("&quot;", "\""), ("&Quot;", "\""), ("&#x27;", "'"), ('&#34;', '"'), ('&#39;', '\''), ('&#039;', '\''),
				('&#x00c4', 'Ä'), ('&#x00e4', 'ä'), ('&#x00d6', 'Ö'), ('&#x00f6', 'ö'), ('&#x00dc', 'Ü'), ('&#x00fc', 'ü'), ('&#x00df', 'ß'), ('&#xD;', ''), ('\xc2\xb7', '-'),
				('&szlig;', 'ß'), ('&mdash;', '-'), ('&ndash;', '-'), ('&Auml;', 'Ä'), ('&Euml;', 'Ë'), ('&Iuml;', 'Ï'), ('&Ouml;', 'Ö'), ('&Uuml;', 'Ü'), ('&auml;', 'ä'), ('&ouml;', 'ö'), ('&uuml;', 'ü'),
				('&auml;', 'ä'), ('&euml;', 'ë'), ('&iuml;', 'ï'), ('&ouml;', 'ö'), ('&uuml;', 'ü'), ('&#376;', 'Ÿ'), ('&yuml;', 'ÿ'),
				('&agrave;', 'à'), ('&Agrave;', 'À'), ('&aacute;', 'á'), ('&Aacute;', 'Á'), ('&acirc;', 'â'), ('&Acirc;', 'Â'), ('&egrave;', 'è'), ('&Egrave;', 'È'), ('&eacute;', 'é'), ('&Eacute;', 'É'), ('&ecirc;', 'ê'), ('&Ecirc;', 'Ê'),
				('&igrave;', 'ì'), ('&Igrave;', 'Ì'), ('&iacute;', 'í'), ('&Iacute;', 'Í'), ('&icirc;', 'î'), ('&Icirc;', 'Î'), ('&ograve;', 'ò'), ('&Ograve;', 'Ò'), ('&oacute;', 'ó'), ('&Oacute;', 'ó'), ('&ocirc;', 'ô'), ('&Ocirc;', 'Ô'),
				('&ugrave;', 'ù'), ('&Ugrave;', 'Ù'), ('&uacute;', 'ú'), ('&Uacute;', 'Ú'), ('&ucirc;', 'û'), ('&Ucirc;', 'Û'), ('&yacute;', 'ý'), ('&Yacute;', 'Ý'),
				('&atilde;', 'ã'), ('&Atilde;', 'Ã'), ('&ntilde;', 'ñ'), ('&Ntilde;', 'Ñ'), ('&otilde;', 'õ'), ('&Otilde;', 'Õ'), ('&Scaron;', 'Š'), ('&scaron;', 'š'), ('&ccedil;', 'ç'), ('&Ccedil;', 'Ç'),
				('&alpha;', 'a'), ('&Alpha;', 'A'), ('&aring;', 'å'), ('&Aring;', 'Å'), ('&aelig;', 'æ'), ('&AElig;', 'Æ'), ('&epsilon;', 'e'), ('&Epsilon;', 'Ε'), ('&eth;', 'ð'), ('&ETH;', 'Ð'), ('&gamma;', 'g'), ('&Gamma;', 'G'),
				('&oslash;', 'ø'), ('&Oslash;', 'Ø'), ('&theta;', 'θ'), ('&thorn;', 'þ'), ('&THORN;', 'Þ'), ('&bull;', '•'), ('&iexcl;', '¡'), ('&iquest;', '¿'), ('&copy;', '(c)'), ('&nbsp;', ' '), ('&hellip;', '...'), ('\n', ''), ('\t', ''), ('<br />', ' - '),
				("\\'", "'"), ("&rsquo;", "’"), ("&lsquo;", "‘"), ("&sbquo;", "’"), ('&rdquo;', '”'), ('&ldquo;', '“'), ('&bdquo;', '”'), ('&rsaquo;', '›'), ('lsaquo;', '‹'), ('&raquo;', '»'), ('&laquo;', '«')):
				text = text.replace(*n)
	return text.strip()

def parameters_string_to_dict(parameters):
	paramDict = {}
	if parameters:
		paramPairs = parameters[1:].split('&')
		for paramsPair in paramPairs:
			paramSplits = paramsPair.split('=')
			if (len(paramSplits)) == 2:
				paramDict[paramSplits[0]] = paramSplits[1]
	return paramDict

params = parameters_string_to_dict(sys.argv[2])
name = unquote_plus(params.get('name', ''))
url = unquote_plus(params.get('url', ''))
mode = unquote_plus(params.get('mode', 'root'))
origSERIE = unquote_plus(params.get('origSERIE', ''))
extras  = unquote_plus(params.get('extras', 'standard'))
IDENTiTY = unquote_plus(params.get('IDENTiTY', ''))
cineType = unquote_plus(params.get('cineType', ''))
